$!
$!                     VMS Makefile for Mongo.
$!
$!    (See Section 5 of the Appendix of the Mongo manual for details)
$!
$! First of all compile the source
$!
$ copy [.sysdepvms]compile.com,flib.com,fortlib.com,link.com []
$ library /create [-]mongo
$ @compile devices
$ @compile interact
$ @compile plotsub
$ @compile sysdepvms
$ @link
$ delete compile.com;*,flib.com;*,fortlib.com;*,link.com;*
$!
$! Create the binary font file
$!
$ fortran crunch.f
$ link crunch
$ run crunch
$ delete crunch.exe;*,crunch.obj;*
$!
$! Installation varies by system.
$!
$! 0. Naturally, you should first place MONGO.EXE and MONGO.OLB wherever
$! you would like them to reside.
$!
$! 1. In general you want to decide where to put the auxiliary files, let
$! us presume that it is a directory [mongo].  
$!
$! 2. In order to set this choice as a default, alter the file 
$! [.SYSDEPVMS]BLOCKDATA.FOR and recompile.
$!
$! 3. The file [.SYSDEPVMS]MONGOFILES.DAT carries pointers to the help file
$! font file, and raster command file.  It needs to be altered to reflect
$! the location you choose for these files. 
$!
$! 4. Copy MONGOFILES.DAT, HELP.DAT, and FONTS.BIN to this location.
$!
$! 5. Decide which printer you have (e.g. Postscript [lwrast], Imagen [imrast]
$! or QMS [lgrast], alter the file [.RASTERVMS]CMDFILE.DAT, to agree with
$! the directory where you will place the rasterizer program(s), and copy it 
$! to the directory used in MONGOFILES.DAT.  See the manual for more 
$! discussion on this.
$!
$! 6. Alter the rasterization command procedure associated with the rasterizer
$! appropriate for your printer (e.g. [.RASTERVMS]LWRAST.COM for a Postscript
$! printer) according to the instructions there.  Copy to the location 
$! specified by CMDFILE.DAT.
$! 
$! 7. Compile the actual rasterizer program (e.g. LWRASTER.FOR for a 
$! Postscript printer) and copy to the location pointed to by CMDFILE.DAT.
$! Again, see the manual for more discussion.
$!
$! With any luck Mongo should run perfectly.  Remember that the way Mongo
$! finds its font file, help file, and pointers to hardcopy routines is via
$!    (BLOCKDATA.FOR or logical variable MONGOFILES)
$!                      ====>
$!     MONGOFILES.DAT
$!                      ====>
$!    (HELP.DAT, FONTS.BIN, CMDFILE.DAT)
$!                      ====>
$!     Rasterizer command procedure
$!                      ====>
$!     Rasterizer program
$! 
$! If you have problems with finding the font file, for example, check
$! very carefully that this chain is set up properly and intact.
$!
