#include <stdio.h>

static int	mychildpid = 0;

main(argc,argv)
int argc;
char **argv;
{
  int pfdin[2], pfdout[2], nread, nline;
  char line[1024], *c, *rl_gets(), prompt[20];
  char  *chargv[6], chargs[6][32];

/* Open pipes and fork */
  if( pipe(pfdin) == -1 || pipe(pfdout) == -1) 
    fprintf(stderr, "can't open pipe\n");

  switch( (mychildpid=fork()) ) {

  case -1:
    fprintf(stderr,"can't fork\n");
    break;

  case 0:

/* Create args for process we are about to exec */
    strcpy(chargs[0], "mongoin");         chargv[0] = chargs[0];
    strcpy(chargs[1], "-in");             chargv[1] = chargs[1];
    sprintf(chargs[2], "%d", pfdout[0]);  chargv[2] = chargs[2];
    strcpy(chargs[3], "-out");            chargv[3] = chargs[3];
    sprintf(chargs[4], "%d", pfdin[1]);   chargv[4] = chargs[4];
    chargv[5] = NULL;

/* Close the unused child descriptors */
    if(close(pfdout[1]) == -1 || close(pfdin[0]) == -1)
      fprintf(stderr,"Error closing child's pipes\n");
 
/* Go off and do our thing */
    fprintf(stderr, "About to exec\n");
    execvp("mongoin", chargv);
    fprintf(stderr, "Sorry, exec failed\n");
 
  default:
    ;
  }

/* Meanwhile back at the parent */

  fprintf(stderr, "parent: working on input\n");

/* Close the unused parent descriptors */
  if(close(pfdout[0]) == -1 || close(pfdin[1]) == -1)
    fprintf(stderr,"Error closing parent's pipes\n");
  
  fprintf(stderr,"Parent: in/out = %d %d\n", pfdin[0], pfdout[1]);
 
/* And read and echo forever */
  for(nline=0 ; ; nline++) {

/* Create a prompt and write it */
    sprintf(prompt, "%03d:", nline);
    write(pfdout[1], prompt, strlen(prompt));

/* See what the child has for us */
    nread = read(pfdin[0], line, 1024);

/* EOF? */
    if(line[0] == EOF) {
      fprintf(stderr, "parent EOF, quit time\n");
      kill(mychildpid, 9);
      break;
    }

/* Process the line */
    line[nread] = '\0';
    printf("parent (%2d): %s\n", nread, line);
  }
    
}


