#include <stdio.h>

static int	mychildpid = 0;

main(argc,argv)
int argc;
char **argv;
{
  int pfd[2], nread, nline;
  char line[1024], *c, *rl_gets(), prompt[20];

/* Open pipes and fork */
  if( pipe(pfd) == -1) fprintf(stderr, "can't open pipe\n");
  switch( (mychildpid=fork()) ) {

  case -1:
    fprintf(stderr,"can't fork\n");
    break;

  case 0:

/* We are the child, keep stdin and stdout for input processing */

/* Go off and spend the rest of our life reading and writing */
    while(1) {

/* Get a prompt */
      nread = read(pfd[1], prompt, 20);
      prompt[nread] = '\0';

/* And read a processed line */
      c = rl_gets(prompt, line);
      nread = strlen(line);

/* End of file? */
      if(c == NULL) {
/*	fprintf(stderr,"Child EOF\n"); */
	write(pfd[1], "\0", 1);
      }
      /*
      nread = read(0, line, 1024);
      line[nread] = '\0';
      fprintf(stderr,"child (%3d): %s\n", nread, line);
      */

/* Send it back to the parent */
      write(pfd[1], line, nread);
    }
  default:
    ;
  }

/* Meanwhile back at the parent */

/* And read and echo forever */
  for(nline=0 ; ; nline++) {

/* Create a prompt and write it */
    sprintf(prompt, "%03d:", nline);
    write(pfd[0], prompt, strlen(prompt));

/* See what the child has for us */
    nread = read(pfd[0], line, 1024);

/* EOF? */
    if(line[0] == '\0') {
      fprintf(stderr, "parent EOF, quit time\n");
      kill(mychildpid, 9);
      break;
    }

/* Process the line */
    line[nread] = '\0';
    printf("parent (%2d): %s\n", nread, line);
  }
    
}

/* A static variable for holding the line. */
static char *line_read = (char *)NULL;
     
/* Read a string, and return a pointer to it.  Returns NULL on EOF. */
char *rl_gets (prompt, myline)
char *prompt, *myline;
{
  char *strcpy(), *readline();
  /* If the buffer has already been allocated, return the memory
     to the free pool. */
  if (line_read)
    {
      free (line_read);
      line_read = (char *)NULL;
    }

  /* Get a line from the user. */
  line_read = readline (prompt);

  /* If the line has any text in it, save it on the history. */
  if (line_read && *line_read) add_history (line_read);

  if(line_read == NULL) return(NULL);
  strcpy(myline, line_read);
  return (myline);
}

