CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGORETROSETUP
      INCLUDE 'mongo.par'
      LX1 = 0
      LX2 = 639
      LY1 = 0
      LY2 = 479
      GX1 = 50
      GX2 = 610
      GY1 = 40
      GY2 = 460
      CHEIGHT = 32
      CWIDTH = 20
      EXPAND = 1.
      ANGLE = 0.
      CXDEF = .4
      CYDEF = .4
      PXDEF = 4.
      PYDEF = 4.
      COFF = -4
      TERMOUT = .TRUE.
      XYSWAPPED = .FALSE.
      AUTODOT = .TRUE.
      AUTOWEIGHT = .FALSE.
      AUTOCHAR = .TRUE.
      RETURN
      END

      SUBROUTINE MGORETROSELECT
      RETURN
      END

      SUBROUTINE MGORETROLINE(IX1,IY1,IX2,IY2)
C MODE = 0/1 for alpha/graphics mode
      COMMON /MGORETRO/ IXL, IXH, IYL, IYH, IXP, IYP, MODE

      IF(MODE.NE.1 .OR. IX1.NE.IXP .OR. IY1.NE.IYP) THEN
          CALL MGORETRORELOC(IX1,IY1)
      END IF
      CALL MGORETRODRAW(IX2,IY2)
      RETURN
      END

      SUBROUTINE MGORETRORELOC(IX,IY)
C---------------------
C     Moves graphic pointer to IX,IY
C---------------------
      COMMON /MGORETRO/ IXL, IXH, IYL, IYH, IXP, IYP, MODE
C Set the old position variables so all bytes are output
C Set IXL etc to -1 (illegal coordinate) so that TDRAW sends all four bytes
      IXL = -1
      IXH = -1
      IYL = -1
      IYH = -1
      CALL MGOTTWRITE(1,CHAR(29))
      MODE = 1
      CALL MGORETRODRAW(IX,IY)
      RETURN
      END

      SUBROUTINE MGORETRODRAW(IX,IY)
C---------------------
C     Outputs coordinates IX, IY
C---------------------
C Undo Retrographics 4010 imitation
      CHARACTER*4 OUTBUF
      COMMON /MGORETRO/ IXL, IXH, IYL, IYH, IXP, IYP, MODE
      IXD = 8*(IX/5) + (MOD(IX,5)*7)/4
      IYD = 13*(IY/8) + (MOD(IY,8)*7)/4
C Compute four bytes in 4010 style format
      IXLD = MOD(IXD,32) + 64
      IXHD = IXD/32 + 32
      IYLD = MOD(IYD,32) + 96
      IYHD = IYD/32 + 32
      N = 0
      IF(IYHD.NE.IYH) THEN
          N = N + 1
          OUTBUF(N:N) = CHAR(IYHD)
          IYH = IYHD
      END IF
      IF(IYLD.NE.IYL.OR.IXHD.NE.IXH) THEN
          N = N + 1
          OUTBUF(N:N) = CHAR(IYLD)
          IYL = IYLD
      END IF
      IF(IXHD.NE.IXH) THEN
          N = N + 1
          OUTBUF(N:N) = CHAR(IXHD)
          IXH = IXHD
      END IF
      N = N + 1
      OUTBUF(N:N) = CHAR(IXLD)
      IXL = IXLD
      CALL MGOTTWRITE(N,OUTBUF)
      IXP = IX
      IYP = IY
      RETURN
      END

      SUBROUTINE MGORETROCHAR(NCHAR,CBUF)
      CHARACTER*(*) CBUF
      COMMON /MGORETRO/ IXL, IXH, IYL, IYH, IXP, IYP, MODE
      IF(MODE.EQ.1) THEN
          CALL MGOTTWRITE(1,CHAR(31))
          MODE = 0
      END IF
      CALL MGOTTWRITE(NCHAR,CBUF)
      RETURN
      END

      SUBROUTINE MGORETROLTYPE(ILT)
      CHARACTER*1 LTYPE(8), EC, GS
      CHARACTER*27 USERLINE
      LOGICAL LOADED
      CHARACTER*3 OUTBUF
      COMMON /MGORETRO/ IXL, IXH, IYL, IYH, IXP, IYP, MODE
      DATA LOADED /.FALSE./
      DATA LTYPE /'`','x','a','c','y','z','b','d'/
      IF(.NOT.LOADED) THEN
          EC = CHAR(27)
          GS = CHAR(29)
          USERLINE = GS//EC//'/1;1a'//EC//'/4;2;1;2b'//EC//'/8;2;1;2c'
          CALL MGOTTWRITE(27,USERLINE)
          LOADED = .TRUE.
      END IF
      IARG = ILT + 1
      IF(ILT.LT.1.OR.ILT.GT.8) IARG = 1
      OUTBUF(1:3) = GS // EC // LTYPE(IARG)
      CALL MGOTTWRITE(3,OUTBUF)
      MODE = 0
      RETURN
      END

      SUBROUTINE MGORETROERASE
      CHARACTER*3 OUTBUF
      COMMON /MGORETRO/ IXL, IXH, IYL, IYH, IXP, IYP, MODE
      OUTBUF(1:3) = CHAR(29) // CHAR(27) // CHAR(12)
      CALL MGOTTWRITE(3,OUTBUF)
      MODE = 0
      RETURN
      END

      SUBROUTINE MGORETROIDLE
      CHARACTER*3 TIDLES
      COMMON /MGORETRO/ IXL, IXH, IYL, IYH, IXP, IYP, MODE
      TIDLES(1:3) = CHAR(29) // CHAR(32) // CHAR(24)
      CALL MGOTTWRITE(3,TIDLES)
      CALL MGOTTFLUSH
      MODE = 0
      RETURN
      END

      SUBROUTINE MGORETROCURS(IX,IY,IREAD)
* Retrocurs obtains the key struck and the location (ix,iy)
* Note: the trailer codes must be set to   0D   and   FF
      CHARACTER*1 KEY
      CHARACTER*5 BUF
* If IREAD = 0, just set the cursor location, but don't read it
      IF(IREAD.EQ.0) THEN
          CALL MGORETRORELOC(IX,IY)
          WRITE(BUF,'(A,A)') CHAR(27), '/f'
          CALL MGOTTWRITE(3,BUF)
          RETURN
      END IF
      CALL MGORETROIDLE
      WRITE(6,'(1X,A,$)') 'Position the cursor and hit <space> '
      WRITE(BUF,'(A,A,A)') CHAR(29),CHAR(27),'"4g'
      CALL MGOTTWRITE(5,BUF)
      CALL MGOTTFLUSH
      CALL MGOTTREAD(N,BUF)
* Check to see if the key struck was a terminator (probably <cr>)
      IF(N.LT.5.AND.ICHAR(BUF(1:1)).EQ.13) THEN
          CALL MGOTTREAD(N,BUF(2:))
      END IF
      KEY = BUF(1:1)
      I32 = 32
      IXTEK = (ICHAR(BUF(2:2))-I32)*I32 + ICHAR(BUF(3:3)) - I32
      IYTEK = (ICHAR(BUF(4:4))-I32)*I32 + ICHAR(BUF(5:5)) - I32
      IX = 5*(IXTEK/8) + (2*MOD(IXTEK,8)+1)/3
      IY = 8*(IYTEK/13) + (2*MOD(IYTEK,13)+1)/3
      RETURN
      END
