CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGOXSETUP
      INCLUDE 'mongo.par'
      INCLUDE 'files.par'
      CHARACTER*20 TDEV
      IF(INDEX(TERMDEV(lastterm),':').GT.0) THEN
          CALL MGOXWINSELECT(TERMDEV(lastterm)(:MGOLENC(TERMDEV)) //
     $        CHAR(0))
      END IF
      TDEV = TERMDEV(LASTTERM)
      CALL MGOLOWER(TDEV)
      IF(TDEV(1:4).EQ.'port') THEN
         MINIFY = 4
         IXSIZE = 2450
         IYSIZE = 3300
      ELSE IF(TDEV(1:4).EQ.'land') THEN
         MINIFY = -4
         IXSIZE = 3300
         IYSIZE = 2450
      ELSE
         MINIFY = 0
         IXSIZE = 800
         IYSIZE = 600
      END IF
      NPALETTE = MAXPALETTE
      CALL MGOXWINOPEN(IXSIZE, IYSIZE, MINIFY, ICOLOR,NPALETTE,PALETTE)
      LX1 = 0
      LX2 = IXSIZE
      LY1 = 0
      LY2 = IYSIZE
      CHEIGHT = 32
      CWIDTH = 20
      EXPAND = 1.
      ANGLE = 0.
      IF(MINIFY .EQ. 0) THEN
         CXDEF = 0.45
         CYDEF = 0.46875
         PXDEF = 4.
         PYDEF = 4.
         COFF = -4
         GX1 = 5*CWIDTH*CXDEF + 2*CHEIGHT*CXDEF
         GX2 = LX2 - 4*CWIDTH*CXDEF
         GY1 = 4*CHEIGHT*CYDEF
         GY2 = LY2 - 2*CHEIGHT*CYDEF
         AUTOCHAR = .TRUE.
      ELSE
         CXDEF = 2.
         CYDEF = 2.
         PXDEF = 12.
         PYDEF = 12.
         GX1 = 500
         IF(MINIFY.GT.0) THEN
            GX2 = 2300
            GY1 = 500
            GY2 = 3000
         ELSE
            GX2 = 3100
            GY1 = 400
            GY2 = 2300
         END IF
         AUTOCHAR = .FALSE.
      END IF
      TERMOUT = .TRUE.
      XYSWAPPED = .FALSE.
      AUTODOT = .TRUE.
      AUTOWEIGHT = .TRUE.
      RETURN
      END

      SUBROUTINE MGOXRESIZE(IXSIZE,IYSIZE)
      INCLUDE 'mongo.par'
      LX2 = IXSIZE
      LY2 = IYSIZE
      GX2 = LX2 - 4*CWIDTH*CXDEF
      GY2 = LY2 - 2*CHEIGHT*CYDEF
      RETURN
      END

      SUBROUTINE MGOXSELECT
      RETURN
      END

      SUBROUTINE MGOXLINE(IX1,IY1,IX2,IY2)
      COMMON /MGOX/ IXP, IYP, MODE

      CALL MGOXWINVEC(IX1,IY1,IX2,IY2)
      IXP = IX2
      IYP = IY2
      RETURN
      END

      SUBROUTINE MGOXRELOC(IX,IY)
C---------------------
C     Moves graphic pointer to IX,IY
C---------------------
      COMMON /MGOX/ IXP, IYP, MODE
      IXP = IX
      IYP = IY
      RETURN
      END

      SUBROUTINE MGOXDRAW(IX,IY)
C---------------------
C     Outputs coordinates IX, IY
C---------------------
      COMMON /MGOX/ IXP, IYP, MODE
      CALL MGOXLINE(IXP,IYP,IX,IY)
      RETURN
      END

      SUBROUTINE MGOXCHAR(NCHAR,CBUF)
      CHARACTER*(*) CBUF
      COMMON /MGOX/ IXP, IYP, MODE
      CALL MGOXWINCHAR(IXP,IYP,NCHAR,CBUF)
      RETURN
      END

      SUBROUTINE MGOXLTYPE(ILT)
      CALL MGOXWINLTYPE(ILT)
      RETURN
      END

      SUBROUTINE MGOXLWEIGHT(ILW)
      CALL MGOXWINLWEIGHT(ILW)
      RETURN
      END

      SUBROUTINE MGOXCOLOR(IC)
      CALL MGOXWINCOLOR(IC)
      RETURN
      END

      SUBROUTINE MGOXPALETTE(IC,PALETTE)
      INTEGER*2 PALETTE(3)
      CALL MGOXWINPALETTE(IC,PALETTE)
      RETURN
      END

      SUBROUTINE MGOXFILL(IFILL,IRELOC)
      CALL MGOXWINFILL(IFILL,IRELOC)
      RETURN
      END

      SUBROUTINE MGOXERASE
      CALL MGOXWINERASE
      RETURN
      END

      SUBROUTINE MGOXIDLE
      COMMON /MGOX/ IXP, IYP, MODE
      CALL MGOXWINIDLE
      RETURN
      END

      SUBROUTINE MGOXCURS(IX,IY,IREAD)
* XCURS obtains the key struck and the location (IX,IY)
* If IREAD = 0, just set the cursor location, but don't read it
      INCLUDE 'mongo.par'
      IF(IREAD.EQ.0) THEN
          CALL MGOXRELOC(IX,IY)
      ELSE
          CALL MGOUT('Position the cursor and press any key')
      END IF
      DX = (X2-X1) / (GX2-GX1)
      X0 = X1 - DX*GX1
      DY = (Y2-Y1) / (GY2-GY1)
      Y0 = Y1 - DY*GY1
      CALL MGOXWINCURS(IX,IY,IREAD,X0,DX,Y0,DY)
      RETURN
      END
