CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGOMAXECUTE(IMAC,ARGLIST,ERROR,DATA)
      INCLUDE 'vocab.par'
      PARAMETER (MAXLEVEL=8)
      CHARACTER*(*) ARGLIST
      CHARACTER*80 LINE, REST
      CHARACTER*20 COMMAND
      LOGICAL ERROR, SAVE, MACRO
      INTEGER LEVEL
      CHARACTER*40 MACARG(0:9,MAXLEVEL), ORIGARG(9)
      INTEGER MACNUM(MAXLEVEL), MACPTR(MAXLEVEL), NDONE(MAXLEVEL)
      COMMON /MAXECLEVEL/ LEVEL, MACARG

      LEVEL = 0
      LASTPAR = -1

* This is the start, jump here for recursion
1     continue
      IF(IFSKIP.GT.0) THEN
         IFSKIP = 0
         GOTO 999
      END IF

      LEVEL = LEVEL + 1
      IF(LEVEL.GT.MAXLEVEL) THEN
          CALL MGOERR(' Macro level too deep')
          GOTO 999
      END IF

* Set up macro and argument stack entries
      MACNUM(LEVEL) = IMAC
      MACPTR(LEVEL) = MACBEG(IMAC)
      NDONE(LEVEL) = 0
      DO 9 I = 1,9
         MACARG(I,LEVEL) = ' '
9     CONTINUE
      IP = 1
      DO 10 I = 1,9
         CALL MGOPARSE(ARGLIST(IP:),MACARG(I,LEVEL),LENPAR,NEXTPAR)
         IF(LASTPAR.LT.0) ORIGARG(I) = MACARG(I,LEVEL)
         IP = IP + NEXTPAR - 1
         IF(LENPAR.EQ.0.OR.IP.GT.LEN(ARGLIST)) THEN
            WRITE(MACARG(0,LEVEL),'(I1)') I - 1
            IF(LASTPAR.LT.0) LASTPAR = I - 1
            GOTO 11
         END IF
10    CONTINUE
      MACARG(0,LEVEL) = '9'
      IF(LASTPAR.LT.0) LASTPAR = 9
11    CONTINUE

* Now retrieve the commands from the buffer
2     CONTINUE
      DO 3 M = 1,MACLEN(MACNUM(LEVEL)) - NDONE(LEVEL)
          MGOLENCOM = ICHAR(COMBUF(MACPTR(LEVEL)))
          LINE = ' '
          DO 901 I = 1,MGOLENCOM-1
             IF(MACNUM(LEVEL).EQ.1) THEN
                LINE(I:I) = COMBUF(MACPTR(LEVEL)+I)
             ELSE
                LINE(I:I) = COMBUF(MACPTR(LEVEL)+I-MGOLENCOM)
             END IF
 901      CONTINUE

* Substitute the arguments, work back to front to permit funny &&1 constructs.
          DO 30 I = MGOLENCOM-1,1,-1
             IF(LINE(I:I).NE.'&') GOTO 30
* Convert "&#" to "&" to convert "&#1" to "&1"
             IF(LINE(I+1:I+1).eq.'#') THEN
                REST = LINE(1:I) // LINE(I+2:)
                LINE = REST
                GOTO 30
             END IF
             NARG = ICHAR(LINE(I+1:I+1)) - ICHAR('0')
* Do we have 0-9 following a "&"?
             IF(NARG.LT.0 .OR. NARG.GT.9) GOTO 30
             LARG = MGOLENC(MACARG(NARG,LEVEL))
             REST = LINE(1:I-1) //
     1            MACARG(NARG,LEVEL)(1:LARG) //
     1            LINE(I+2:MGOLENC(LINE))
             LINE = REST
30        CONTINUE

* Update pointers
          IF(MACNUM(LEVEL).EQ.1) THEN
* I.e. "buffer" which grows up
              MACPTR(LEVEL) = MACPTR(LEVEL) + MGOLENCOM
          ELSE
* I.e. user defined macro which grow down
              MACPTR(LEVEL) = MACPTR(LEVEL) - MGOLENCOM
          END IF

          NDONE(LEVEL) = NDONE(LEVEL) + 1
* Interpret the command
          CALL MGOINTERPRET(LINE,COMMAND,IMAC,REST,SAVE,MACRO,ERROR)
          IF(ERROR) THEN
              CALL MGOERR('Error interpreting macro line ')
              CALL MGOERR(line)
              RETURN
          END IF

* On last command decrement LEVEL before execution to permit tail recursion
          IF(NDONE(LEVEL).GE.MACLEN(MACNUM(LEVEL))) LEVEL = LEVEL - 1

          IF(IFSKIP.GT.0) THEN
             IFSKIP = 0
             GOTO 3
          END IF

* Execute the command if it's a builtin
          IF(.NOT.MACRO) THEN
              CALL MGOEXECUTE(COMMAND,REST,ERROR,DATA)
              IF(COMMAND.EQ.'cursor'.AND.LEVEL.EQ.0 .AND.
     1			LASTPAR.LT.8) THEN
                  CALL MGOPARSE(REST,MACARG(LASTPAR+1,1),LENPAR,NXT)
                  CALL MGOPARSE(REST(NXT:),MACARG(LASTPAR+2,1),
     1			LENPAR,NXT)
                  LASTPAR = LASTPAR + 2
              END IF
          END IF

* If a break command, terminate this macro and continue
          IF(NBREAK.GT.0) THEN
             LEVEL = MAX(0, LEVEL-NBREAK)
             NBREAK = 0
             GOTO 4
          END IF

* If a macro go and do it
          IF(MACRO) THEN
              ARGLIST = REST
              GOTO 1
          END IF
             
3     CONTINUE
4     CONTINUE
      IF(LEVEL.GT.0) GOTO 2
      IP = 1
      ARGLIST = ' '
      DO 903 I = 1,LASTPAR
          N = MGOLENC(ORIGARG(I))
          ARGLIST(IP:IP+N) = ORIGARG(I)(:N) // ' '
          IP = IP + N + 1
903   CONTINUE
999   CONTINUE
      RETURN
      END


      SUBROUTINE MGOSETMACARG(I, ARG)
      PARAMETER (MAXLEVEL=8)
      CHARACTER*(*) ARG
      CHARACTER*40 MACARG(0:9,MAXLEVEL)
      COMMON /MAXECLEVEL/ LEVEL, MACARG
      IF(LEVEL.LE.0.OR.LEVEL.GT.MAXLEVEL) RETURN
      MACARG(I,LEVEL) = ARG
      READ(MACARG(0,LEVEL),'(I1)') NARG
      IF(I.GT.NARG) WRITE(MACARG(0,LEVEL),'(I1)') I
      RETURN
      END

      SUBROUTINE MGOGETMACARG(I, ARG)
      PARAMETER (MAXLEVEL=8)
      CHARACTER*(*) ARG
      CHARACTER*40 MACARG(0:9,MAXLEVEL)
      COMMON /MAXECLEVEL/ LEVEL, MACARG
      IF(LEVEL.LE.0.OR.LEVEL.GT.MAXLEVEL) THEN
         ARG = ' '
         RETURN
      END IF
      ARG = MACARG(I,LEVEL)
      RETURN
      END
