CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGOREADINPUT(NAME,ERROR,DATA)
      INCLUDE 'luns.par'
      INCLUDE 'vocab.par'
      PARAMETER (MAXINPUT=5)
      CHARACTER*(*) NAME
      CHARACTER*80 LINE, REST
      CHARACTER*20 COMMAND
      LOGICAL ERROR, SAVE, MACRO, TRASH
      LEVEL = 0
      MGOMODE = 1

* Here is the start, jump here for recursion
1     LEVEL = LEVEL + 1
      IF(LEVEL.GT.MAXINPUT) THEN
          CALL MGOERR(' Input level too deep')
          GOTO 999
      END IF

* Open the new file
      OPEN(UNIT=LEVEL+inputlun-1,FILE=NAME,STATUS='OLD',ERR=22)
      TRASH = .FALSE.

* Now retrieve the commands from the file
10    READ(LEVEL+inputlun-1,1000,ERR=2,END=999) LINE
1000  FORMAT(A)

* Execute the command
      IF(MGOMODE.EQ.1) THEN
          CALL MGOINTERPRET(LINE,COMMAND,IMAC,REST,SAVE,MACRO,ERROR)
          IF(ERROR) THEN
              IF(COMMAND.EQ.' ') GOTO 10
              CALL MGOERR('Error interpreting line ')
              CALL MGOERR(LINE)
              LINE = 'from file '//NAME
              CALL MGOERR(LINE)
              RETURN
          END IF

          IF(COMMAND.EQ.'end') GOTO 999

* Is the command another level of file read?
          IF(COMMAND.EQ.'input') THEN
              NAME = REST
              GOTO 1
          END IF

* Now execute the command
          IF(COMMAND.EQ.'define') THEN
              CALL MGOSTARTMAC(REST,ERROR)
* If there is an error read the rest of the macro, and try to continue
              IF(ERROR) TRASH = .TRUE.
              MGOMODE = 2
              GOTO 10
          END IF
          IF(COMMAND.EQ.'insert') THEN
              CALL MGOSTARTINS(REST,ERROR)
              IF(ERROR) RETURN
              MGOMODE = 3
              GOTO 10
          END IF
          IF(MACRO) THEN
              CALL MGOMAXECUTE(IMAC,REST,ERROR,DATA)
          ELSE
              CALL MGOEXECUTE(COMMAND,REST,ERROR,DATA)
          END IF
      ELSE IF(MGOMODE.EQ.2) THEN
          CALL MGOINTERPRET(LINE,COMMAND,NCOM,REST,SAVE,MACRO,ERROR)
* If TRASH is set ignore everything but an END at which point reset TRASH
          IF(TRASH) THEN
              IF(COMMAND.EQ.'end') THEN
                  MGOMODE = 1
                  TRASH = .FALSE.
              END IF
              GOTO 10
          END IF        
* Ignore blank lines, but list erroneous lines or comments
          IF(ERROR) THEN
              IF(MGOLENC(LINE).GT.1.OR.LINE(1:1).NE.' ') THEN
C                  CALL MGOERR2('Not interpreted: ',LINE(:MGOLENC(LINE)))
              END IF
              GOTO 10
          END IF
          LINE = COMMAND(1:MGOLENC(COMMAND)) // ' ' //
     1		REST(1:MGOLENC(REST))
          IF(COMMAND.EQ.'end') THEN
              MGOMODE = 1
              GOTO 10
          END IF
          IF(COMMAND.EQ.'define') THEN
              CALL MGOERR('Macros cannot be nested')
              RETURN
          END IF
          IF(COMMAND.EQ.'insert') THEN
              CALL MGOERR('Macros cannot insert')
              RETURN
          END IF
          CALL MGOSAVEMAC(LINE,ERROR)
      ELSE IF(MGOMODE.EQ.3) THEN
          CALL MGOINTERPRET(LINE,COMMAND,NCOM,REST,SAVE,MACRO,ERROR)
          LINE = COMMAND(1:MGOLENC(COMMAND)) // ' ' //
     1			REST(1:MGOLENC(REST))
          IF(ERROR) RETURN
          IF(COMMAND.EQ.'end') THEN
              MGOMODE = 1
              GOTO 10
          END IF
          CALL MGOINSERT(LINE,ERROR)
      END IF
      GOTO 10

999   CLOSE(LEVEL+inputlun-1)
      LEVEL = LEVEL - 1
      IF(LEVEL.GT.0) GOTO 10
      RETURN

2     CALL MGOERR2('Error reading file ',NAME)
      CALL MGOERR(LINE)
      ERROR = .TRUE.
      RETURN
 22   CALL MGOERR2('Error opening input file ',NAME)
      ERROR = .TRUE.
      RETURN
      END

      SUBROUTINE MGOWRITEMAC(MACNAME,FILENAME,ERROR)
      INCLUDE 'vocab.par'
      INCLUDE 'luns.par'
      CHARACTER*(*) MACNAME,FILENAME
      CHARACTER*20 PAR, LINE
      LOGICAL ERROR, INSERT, MACRO

      CALL MGOLOWER(MACNAME)
* Is this a request to write an array?
      IF(MGOLENC(MACNAME).EQ.1 .AND. 
     $     MACNAME(1:1).GE.'a'.AND.MACNAME(1:1).LE.'z') THEN
         idx = ICHAR(macname(1:1)) - ICHAR('a') + 1
         CALL MGOWRITEDATA(IDX, FILENAME, ERROR)
         RETURN
      END IF

      IF(MACNAME.EQ.'all') GOTO 20
      CALL MGOINTERPRET(MACNAME,PAR,IMAC,LINE,INSERT,MACRO,ERROR)
      IF(.NOT.MACRO) THEN
          CALL MGOERR('Write "macro name" or "all" "filename"')
          ERROR = .TRUE.
          GOTO 999
      END IF
C      OPEN(UNIT=maclun,FILE=FILENAME,STATUS='NEW',ERR=1)
      OPEN(UNIT=maclun,FILE=FILENAME,STATUS='UNKNOWN',ERR=1)
      NEXT = MACBEG(IMAC)
      DO 10 J = 1,MACLEN(IMAC)
      IF(IMAC.EQ.1) THEN
          I1 = NEXT + 1
          I2 = NEXT + ICHAR(COMBUF(NEXT)) - 1
          NEXT = NEXT + ICHAR(COMBUF(NEXT))
      ELSE
          I1 = NEXT - ICHAR(COMBUF(NEXT)) + 1
          I2 = NEXT - 1
          NEXT = NEXT - ICHAR(COMBUF(NEXT))
      END IF
10    WRITE(maclun,1000) (COMBUF(I),I=I1,I2)
1000  FORMAT(80A1)
      GOTO 999

C20    OPEN(UNIT=maclun,FILE=FILENAME,STATUS='NEW',ERR=1)
20    OPEN(UNIT=maclun,FILE=FILENAME,STATUS='UNKNOWN',ERR=1)
      DO 21 K = 2,NMAC
      NEXT = MACBEG(K)
      WRITE(maclun,1001) 'define ', VOCAB(NBUILTIN+K)(2:)
1001  FORMAT(A,A)
      DO 22 J = 1,MACLEN(K)
      I1 = NEXT - ICHAR(COMBUF(NEXT)) + 1
      I2 = NEXT - 1
      NEXT = NEXT - ICHAR(COMBUF(NEXT))
22    WRITE(maclun,1000) (COMBUF(I),I=I1,I2)
      WRITE(maclun,1001) 'end'
21    WRITE(maclun,1001)
      NEXT = MACBEG(1)
      DO 23 J = 1,MACLEN(1)
      I1 = NEXT + 1
      I2 = NEXT + ICHAR(COMBUF(NEXT)) - 1
      NEXT = NEXT + ICHAR(COMBUF(NEXT))
23    WRITE(maclun,1000) (COMBUF(I),I=I1,I2)
      GOTO 999

1     CALL MGOERR2('Error opening output file ',FILENAME)
      ERROR = .TRUE.
999   CONTINUE
      IF(.NOT.ERROR) CLOSE(maclun)
      RETURN
      END

      SUBROUTINE MGOPLAYBACK(MACNAME,ERROR,DATA)
      INCLUDE 'vocab.par'
      INCLUDE 'luns.par'
      CHARACTER*(*) MACNAME
      CHARACTER*80 LINE
      CHARACTER*80 REST
      CHARACTER*20 COMMAND
      LOGICAL ERROR, INSERT, MACRO
      CALL MGOPARSE(MACNAME,COMMAND,LENPAR,NEXT)
      IF(LENPAR.EQ.0) MACNAME = 'buffer'
      CALL MGOINTERPRET(MACNAME,COMMAND,IMAC,LINE,INSERT,MACRO,ERROR)
      IF(.NOT.MACRO) THEN
          CALL MGOERR('Playback "macro name"')
          ERROR = .TRUE.
          RETURN
      END IF
      NEXT = MACBEG(IMAC)
      DO 10 J = 1,MACLEN(IMAC)
      IF(IMAC.EQ.1) THEN
          I1 = NEXT + 1
          I2 = NEXT + ICHAR(COMBUF(NEXT)) - 1
          NEXT = NEXT + ICHAR(COMBUF(NEXT))
      ELSE
          I1 = NEXT - ICHAR(COMBUF(NEXT)) + 1
          I2 = NEXT - 1
          NEXT = NEXT - ICHAR(COMBUF(NEXT))
      END IF
      DO 11 I = 1,80
      IF(I.LE.I2-I1+1) THEN
          LINE(I:I) = COMBUF(I+I1-1)
      ELSE
          LINE(I:I) = ' '
      END IF
11    CONTINUE

      CALL MGOINTERPRET(LINE,COMMAND,NCOM,REST,INSERT,MACRO,ERROR)
      LINE = COMMAND(1:MGOLENC(COMMAND)) // REST(1:MGOLENC(REST))
      IF(ERROR) RETURN
      IF(COMMAND.EQ.'define') THEN
          CALL MGOERR('Playback does not allow define')
          RETURN
      END IF
      IF(COMMAND.EQ.'insert') THEN
          CALL MGOERR('Playback does not allow insert')
          RETURN
      END IF
      IF(COMMAND.EQ.'playback') THEN
          CALL MGOERR('Playback can not be nested')
          RETURN
      END IF
      IF(MACRO) THEN
          CALL MGOMAXECUTE(NCOM,REST,ERROR,DATA)
          IF(ERROR) RETURN
      ELSE
          CALL MGOEXECUTE(COMMAND,REST,ERROR,DATA)
          IF(ERROR) RETURN
      END IF
10    CONTINUE
      RETURN
      END

      SUBROUTINE MGORESET
      RETURN
      END

