CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGORELOCATE(X,Y)
      INCLUDE 'mongo.par'
      XP = GX1 + (GX2-GX1)*(X-X1)/(X2-X1)
      YP = GY1 + (GY2-GY1)*(Y-Y1)/(Y2-Y1)
      RETURN
      END

      SUBROUTINE MGOGRELOCATE(X,Y)
      INCLUDE 'mongo.par'
      XP = X
      YP = Y
      RETURN
      END

      SUBROUTINE MGODRAW(X,Y)
      INCLUDE 'mongo.par'
      XQ = GX1 + (GX2-GX1)*(X-X1)/(X2-X1)
      YQ = GY1 + (GY2-GY1)*(Y-Y1)/(Y2-Y1)
      CALL MGOGDRAW(XQ,YQ)
      RETURN
      END

      SUBROUTINE MGOGDRAW(X,Y)
      INCLUDE 'mongo.par'
      LOGICAL OK

      IF(XP.GE.GX1.AND.XP.LE.GX2.AND.YP.GE.GY1.AND.YP.LE.GY2 .AND.
     1  X.GE.GX1.AND.X.LE.GX2.AND.Y.GE.GY1.AND.Y.LE.GY2) THEN
          CALL MGOLINE(XP,YP,X,Y)
      ELSE
          CALL MGOCROSS(XP,YP,X,Y,GX1,GX2,GY1,GY2,XC,YC,XD,YD,OK)
          IF(OK) CALL MGOLINE(XC,YC,XD,YD)
      ENDIF

10    XP = X
      YP = Y
      RETURN
      END

      SUBROUTINE MGOCROSS(XP,YP,XQ,YQ,X1,X2,Y1,Y2,XC,YC,XD,YD,OK)
C Return segment XC,YC,XD,YD where the segment XP,YP,XQ,YQ crosses the
C box X1,Y1,X2,Y2. Set OK to FALSE if never in the box.
C It is assumed that X1 < X2 and Y1 < Y2.
      LOGICAL OK
      XC = XP
      YC = YP
      XD = XQ
      YD = YQ
C Cross left bdy?
      IF((XC-X1)*(XD-X1).LT.0) THEN
          Y = YC + (YD-YC)*(X1-XC)/(XD-XC)
          IF(XC-X1.GT.0) THEN
              XD = X1
              YD = Y
          ELSE
              XC = X1
              YC = Y
          ENDIF
      ENDIF
C Cross right bdy?
      IF((XC-X2)*(XD-X2).LT.0) THEN
          Y = YC + (YD-YC)*(X2-XC)/(XD-XC)
          IF(X2-XC.GT.0) THEN
              XD = X2
              YD = Y
          ELSE
              XC = X2
              YC = Y
          ENDIF
      ENDIF
C Cross bottom bdy?
      IF((YC-Y1)*(YD-Y1).LT.0) THEN
          X = XC + (XD-XC)*(Y1-YC)/(YD-YC)
          IF(YC-Y1.GT.0) THEN
              YD = Y1
              XD = X
          ELSE
              YC = Y1
              XC = X
          ENDIF
      ENDIF
C Cross top bdy?
      IF((YC-Y2)*(YD-Y2).LT.0) THEN
          X = XC + (XD-XC)*(Y2-YC)/(YD-YC)
          IF(Y2-YC.GT.0) THEN
              YD = Y2
              XD = X
          ELSE
              YC = Y2
              XC = X
          ENDIF
      ENDIF

      IF(XC.GE.X1.AND.XC.LE.X2.AND.YC.GE.Y1.AND.YC.LE.Y2 .AND.
     1  XD.GE.X1.AND.XD.LE.X2.AND.YD.GE.Y1.AND.YD.LE.Y2) THEN
          OK = .TRUE.
      ELSE
          OK = .FALSE.
      ENDIF

      RETURN
      END

      SUBROUTINE MGOWINDOW (MX, MY, K)
* Sets the GX and GY so that there are NX windows across and NY windows up
* and down, and the present GX and GY are for the Kth window where the
* counting starts across at the lower left.
* NX = NY = 1 resets to the state before WINDOW was called.
      INCLUDE 'mongo.par'
      real left
      logical pop
      data lastmx /-1000000/

* WINDOW 1 1 means reset the location to the previous ones
      if(mx.eq.1.and.my.eq.1) then
         call mgosubwindow(.true., 0.,0.,0.,0.)
         return
      end if
      
* First of all, pop off the old subwindow
      if(k.ne.0) call mgosubwindow(.true., 0.,0.,0.,0.)

* Margins around plot area for labels
      if(mx.ne.0 .and. my.ne.0) then
         top =   amin1(0.1, cydef*expand*cheight/(gy2-gy1))
         bot =   amin1(0.2, 3*cydef*expand*cheight/(gy2-gy1))
         left =  amin1(0.3, cxdef*expand*(6*cwidth+2*cheight)/(gx2-gx1))
         right = amin1(0.1, cxdef*expand*cheight/(gx2-gx1))
         if(.not.termout) expand = expand * (1./iabs(mx*my))**0.3333
         lastmx = mx
         lastmy = my
      end if

      if(k.eq.0 .or. lastmx.lt.-10000) return

* Which window pane?
      xpane = mod(k-1,iabs(lastmx))
      ypane = (k-1) / iabs(lastmx)

* WINDOW M N K means save the old location values and set new ones
      if (lastmx.gt.0) then
         sx1 =  xpane   *(1+left+right) / iabs(lastmx)
         sx2 = (xpane+1)*(1+left+right) / iabs(lastmx) - left - right
      else
         sx1 =  xpane    / iabs(lastmx)
         sx2 = (xpane+1) / iabs(lastmx)
      end if

      if (lastmy.gt.0) then
         sy1 =  ypane   *(1+top+bot) / iabs(lastmy)
         sy2 = (ypane+1)*(1+top+bot) / iabs(lastmy) - top - bot
      else
         sy1 =  ypane    / iabs(lastmy)
         sy2 = (ypane+1) / iabs(lastmy)
      end if

      call mgosubwindow(.false., sx1,sy1, sx2,sy2)

      return
      end

      subroutine mgosubwindow (pop, sx1,sy1,sx2,sy2)
* Can POP old subwindow from stack and return (SX=0), establish a new
* subwindow at the same level in the hierarchy if POP and SX > 0, or
* push a new hierarchy level and create a new sub-subwindow which is 
* defined by the fractional arguments and the previous window.
      include 'mongo.par'
      parameter (maxstack=10)
      real wstack(5,maxstack)
      logical pop
      data istack /0/

* If GX and GY's have changed since last SUBWINDOW, pop entire stack and
* start over.
      if(istack.eq.0 .or. 
     $     gx1.ne.wstack(1,istack) .or. gy1.ne.wstack(2,istack) .or. 
     $     gx2.ne.wstack(3,istack) .or. gy2.ne.wstack(4,istack)) then
         istack = 1
         wstack(1,istack) = gx1
         wstack(2,istack) = gy1
         wstack(3,istack) = gx2
         wstack(4,istack) = gy2
         wstack(5,istack) = expand
      end if

      if(pop) istack = max(1, istack-1)

      if(sx1.ne.0 .or. sx2.ne.0) then
         istack = istack + 1
         if(istack.gt.maxstack) then
            call mgoerr('MGOSUBWINDOW: stack overflowed')
            istack = maxstack
         end if

         wstack(1,istack) = wstack(1,istack-1) + 
     $        sx1*(wstack(3,istack-1) - wstack(1,istack-1))
         wstack(2,istack) = wstack(2,istack-1) + 
     $        sy1*(wstack(4,istack-1) - wstack(2,istack-1))
         wstack(3,istack) = wstack(1,istack-1) + 
     $        sx2*(wstack(3,istack-1) - wstack(1,istack-1))
         wstack(4,istack) = wstack(2,istack-1) + 
     $        sy2*(wstack(4,istack-1) - wstack(2,istack-1))
         wstack(5,istack) = expand
      end if

      gx1    = wstack(1,istack) 
      gy1    = wstack(2,istack) 
      gx2    = wstack(3,istack) 
      gy2    = wstack(4,istack) 
      expand = wstack(5,istack) 

      return
      end
