CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
* Rasterizer for a Printronix or Trilog Printer
C Printronix printer has 60 dpi, Trilog 100 dpi
C For a Trilog alter NPXDOTS = # of pixels in a plot line and
C NVBUF = (8 lines) * (#pixels in plot line) / (6 pixels/byte) / (2 byte/word)
C       = 2/3 * NPXDOTS
      PARAMETER (NPXDOTS=792)
      PARAMETER (NIN=2048, NBUF=1048576, NVBUF=(2*NPXDOTS)/3)
      INTEGER*2 IBUF(NIN), M1, M2, IX0, IY0
      INTEGER*2 BUF(NBUF)
      INTEGER*2 VBUF(NVBUF)
      INTEGER LIST(NBUF/4), BUFNEXT
      INTEGER*2 SETBIT(12), SIGN
      INTEGER*2 SEGMENT(12,12), BLACK
      INTEGER PX2, PY2
      CHARACTER*80 FILENAME
C This is for CPUs (eg IBM, 68000) with high-byte-first word convention
C      DATA SETBIT /256,512,1024,2048,4096,8192,
C     1			1,2,4,8,16,32/
C This is for VAXs with low-byte-first word convention
      DATA SETBIT /1,2,4,8,16,32,
     1             256,512,1024,2048,4096,8192/
      DATA SIGN /-32768/, BLACK /16191/

* Initialize the segment array
      CALL FILLSEG(SEGMENT,SETBIT)

******************************************************************************
* Vector file contains pairs of 16 bit numbers according to:                 *
*    Sign 1   Sign 2   Mantissa 1   Mantissa 2   Meaning                     *
*      0        0          x            y        Draw a dot at (x,y)         *
*      1        0          x            y        Relocate at (x,y)           *
*      0        1          x            y        Draw to (x,y)               *
*      1        1        32767        32767      End of vector file          *
*      1        1          0            0        Finish plot, start new page *
*      1        1          1            n        Line weight = n             *
*      1        1          2            n        Line type = n               *
* (x,y) are to be plotted in portrait mode                                   *
******************************************************************************

* Read in list of vectors and find how many there are
      LWEIGHT = 1
      LTYPE = 0
      IX0 = 0
      IY0 = 0
      PX2 = 20*NPXDOTS
      PY2 = NPXDOTS
      READ(5,'(A)') FILENAME
      OPEN (UNIT=11,FILE=FILENAME,FORM='UNFORMATTED',STATUS='OLD')

      READ(5,'(A)') FILENAME

      NCOORD = 0
* Read the vector file data and transform them into vectors
      DO 1 J = 1,NBUF/NIN
          READ(11,END=2) IBUF
          DO 3 I = 1,2048,2
              I1 = AND(SIGN,IBUF(I))
              M1 = IBUF(I) - I1
              I2 = AND(SIGN,IBUF(I+1))
              M2 = IBUF(I+1) - I2
              IF(I1.EQ.0) THEN
                  IF(I2.EQ.0) THEN
* Draw a point at m1, m2
                      CALL CHOPPER(M1,M2,M1,M2,LTYPE,LWEIGHT,
     1					PX2,PY2,BUF(NCOORD+1),NV)
                  ELSE
* Draw a line to m1, m2 from previous point
                      CALL CHOPPER(IX0,IY0,M1,M2,LTYPE,LWEIGHT,
     1					PX2,PY2,BUF(NCOORD+1),NV)
                  END IF
                  IX0 = M1
                  IY0 = M2
                  NCOORD = NCOORD + NV
              ELSE
                  IF(I2.EQ.0) THEN
* relocate to m1, m2
                      IX0 = M1
                      IY0 = M2
                  ELSE IF(M1.EQ.32767) THEN
* Quit, end of file
                      GOTO 2
                  ELSE IF(M1.EQ.0) THEN
* Finish plot, start new page
                  ELSE IF(M1.EQ.1) THEN
* Line weight = m2
                      LWEIGHT = M2
                  ELSE IF(M1.EQ.2.AND.M2.GE.0.AND.M2.LE.6) THEN
* Line type = m2
                      LTYPE = M2
                  END IF
              END IF
3         CONTINUE
1     CONTINUE

2     CONTINUE

      NVECTOR = NCOORD / 4

* Arrange vectors so that IX1 .LE. IX2
      DO 5 J = 1,NCOORD,4
      IF(BUF(J).LE.BUF(J+2)) GOTO 5
      I = BUF(J+2)
      BUF(J+2) = BUF(J)
      BUF(J) = I
      I = BUF(J+3)
      BUF(J+3) = BUF(J+1)
      BUF(J+1) = I
5     CONTINUE

* Sort the vectors
      CALL QUICKSORT(NVECTOR,BUF)

      CALL PXOPEN(FILENAME)

      LIST(1) = 2
      LISTNEXT = 2
      BUFNEXT = 1
* Zero raster buffer
      DO 6 I = 1,NVBUF
          VBUF(I) = 0
6     CONTINUE

* Loop over rasters being put out
      DO 10 NRASTER = 0,8*(BUF(NCOORD-1)/8) + 7

      NMOD = MOD(NRASTER,8)
      NOFF = (NVBUF/8)*NMOD + 1

* Build linked list: LIST(1) points to first vector,
* LIST(K) is equivalent to vector K-1, the value of LIST(K) is the next K
* LIST(K) = 0 at the end of the list.
      DO 20 I = BUFNEXT,NVECTOR
      IF(BUF(4*(I-1)+1).GT.NRASTER) GOTO 21
      LIST(LISTNEXT) = I + 2
      LISTNEXT = LISTNEXT + 1
20    BUFNEXT = BUFNEXT + 1
21    LIST(LISTNEXT) = 0

* Now run through the list, plotting this rasters segment of each vector
      LISTPREV = 1
      L = 1
30    L = LIST(L)

* End of list?
      IF(LIST(L).EQ.0) GOTO 15
      IX1 = BUF(4*(L-2)+1)
      IY1 = BUF(4*(L-2)+2)
      IX2 = BUF(4*(L-2)+3)
      IY2 = BUF(4*(L-2)+4)

* Blacken the segment of the versatec raster crossed by the vector
      IF(IX2.EQ.IX1) THEN
          IYM = IY1
          IYP = IY2
          GOTO 40
      END IF
      IF(IY2.EQ.IY1) THEN
          IYM = IY1
          IYP = IY2
          GOTO 40
      END IF
      IYP = IY1 +
     1    NINT(FLOAT(IY2-IY1)/FLOAT(IX2-IX1)*(FLOAT(NRASTER-IX1)+.5))
      IYM = IY1 +
     1    NINT(FLOAT(IY2-IY1)/FLOAT(IX2-IX1)*(FLOAT(NRASTER-IX1)-.5))
      IF(IYP.NE.IYM) THEN
          IF(IYP.LT.IYM) THEN
              IYP = IYP + 1
          ELSE
              IYP = IYP - 1
          END IF
      END IF
      IF(NRASTER.EQ.IX2) IYP = IY2
      IF(NRASTER.EQ.IX1) IYM = IY1

* Blacken VBUF from pixel IYM to IYP inclusive (first = 0)
* Test for special cases for speed
40    IF(IYM.EQ.IYP) THEN
          VBUF(IYM/12+NOFF) = OR(VBUF(IYM/12+NOFF),
     1            SETBIT(MOD(IYM,12)+1))
      ELSE
          IF(IYM.GT.IYP) THEN
              I = IYP
              IYP = IYM
              IYM = I
          END IF
          IF(IYM/12.EQ.IYP/12) THEN
              VBUF(IYM/12+NOFF) = OR(VBUF(IYM/12+NOFF),
     1            SEGMENT(MOD(IYM,12)+1,MOD(IYP,12)+1))
          ELSE
              VBUF(IYM/12+NOFF) = OR(VBUF(IYM/12+NOFF),
     1                SEGMENT(MOD(IYM,12)+1,12))
              VBUF(IYP/12+NOFF) = OR(VBUF(IYP/12+NOFF),
     1                SEGMENT(1,MOD(IYP,12)+1))

              DO 9 I = IYM/12+1+NOFF, IYP/12-1+NOFF
                  VBUF(I) = BLACK
9             CONTINUE
          END IF
      END IF

* Is the vector dead?
      IF(NRASTER.GE.IX2) THEN
          LIST(LISTPREV) = LIST(L)
      ELSE
          LISTPREV = L
      END IF

      GOTO 30

15    CONTINUE
      IF(NMOD.EQ.7) THEN
          CALL PXLINE(8,VBUF)
* Zero raster buffer
          DO 7 I = 1,NVBUF
              VBUF(I) = 0
7         CONTINUE
      END IF
10    CONTINUE

      CALL PXCLOSE

      STOP
      END

      SUBROUTINE QUICKSORT(N,X)
* Sorting program that uses a quicksort algorithm
      REAL*8 X(N)
      REAL*8 TEMP, R8
      INTEGER*2 I2
      EQUIVALENCE (R8,I2)
      PARAMETER (MAXSTACK=1000)
      INTEGER L, R, M, LSTACK(MAXSTACK), RSTACK(MAXSTACK), SP
      INTEGER NSTOP
      LOGICAL MGTL, LGTR, RGTM
      DATA NSTOP /15/

      IF(N.LE.NSTOP) GOTO 50
      SP = 0
      SP = SP + 1
      LSTACK(SP) = 1
      RSTACK(SP) = N

* Sort a subrecord off the stack
* Set KEY = median of X(L), X(M), X(R)
1     L = LSTACK(SP)
      R = RSTACK(SP)
      SP = SP - 1
      M = (L + R) / 2
      R8 = X(L)
      KL = I2
      R8 = X(M)
      KM = I2
      R8 = X(R)
      KR = I2
      MGTL = KM .GT. KL
      RGTM = KR .GT. KM
      LGTR = KL .GT. KR
      IF(MGTL .EQV. RGTM) THEN
          IF(MGTL .EQV. LGTR) THEN
              KEY = KR
          ELSE
              KEY = KL
          END IF
      ELSE
          KEY = KM
      END IF

      I = L
      J = R

* Find a big record on the left
10    R8 = X(I)
      IF(I2.GE.KEY) GOTO 11
      I = I + 1
      GOTO 10
11    CONTINUE
* Find a small record on the right
20    R8 = X(J)
      IF(I2.LE.KEY) GOTO 21
      J = J - 1
      GOTO 20
21    CONTINUE
      IF(I.GE.J) GOTO 2
* Exchange records
      TEMP = X(I)
      X(I) = X(J)
      X(J) = TEMP
      I = I + 1
      J = J - 1
      GOTO 10

* Subfile is partitioned into two halves, left .le. right
* Push the two halves on the stack
2     IF(J-L+1 .GT. NSTOP) THEN
          SP = SP + 1
          IF(SP.GT.MAXSTACK) THEN
              WRITE(6,*) 'Quicksort: stack overflow',SP
              STOP
          END IF
          LSTACK(SP) = L
          RSTACK(SP) = J
      END IF
      IF(R-J .GT. NSTOP) THEN
          SP = SP + 1
          IF(SP.GT.MAXSTACK) THEN
              WRITE(6,*) 'Quicksort: stack overflow',SP
              STOP
          END IF
          LSTACK(SP) = J+1
          RSTACK(SP) = R
      END IF

* Anything left to process?
      IF(SP.GT.0) GOTO 1

50    CONTINUE

      DO 110 J = N-1,1,-1
      K = J
      DO 120 I = J+1,N
      R8 = X(I)
      KI = I2
      R8 = X(J)
      KJ = I2
      IF(KJ.LE.KI) GOTO 121
120   K = I
121   CONTINUE
      IF(K.EQ.J) GOTO 110
      TEMP = X(J)
      DO 130 I = J+1,K
130   X(I-1) = X(I)
      X(K) = TEMP
110   CONTINUE
      RETURN
      END

      SUBROUTINE FILLSEG(SEGMENT,SETBIT)
      INTEGER*2 SETBIT(12), SEGMENT(12,12)
      DO 10 J = 1,12
      DO 10 I = 1,12
10    SEGMENT(I,J) = 0
      DO 20 J = 1,12
      DO 20 I = 1,12
      DO 20 NB = I,J
20    SEGMENT(I,J) = OR(SEGMENT(I,J),SETBIT(NB))
      RETURN
      END

      SUBROUTINE PXOPEN(FILENAME)
      CHARACTER*(*) FILENAME
      OPEN(UNIT=10,NAME=FILENAME,STATUS='NEW',FORM='UNFORMATTED')
      RETURN
      END

      SUBROUTINE PXCLOSE
      CLOSE(10)
      RETURN
      END

      SUBROUTINE PXLINE(NLINE,BUF)
      PARAMETER (NWORD=132/2)
      INTEGER*2 BUF(1), HIBITSON
      CHARACTER CTRLE, CR, LF
      DATA HIBITSON /-16192/

      CTRLE = CHAR(5)
      CR = CHAR(13)
      LF = CHAR(10)
      DO 10 J = 0,NLINE-1
      DO 900 I = 1,NWORD
          BUF(I+J*NWORD) = OR(BUF(I+J*NWORD),HIBITSON)
900   CONTINUE
10    WRITE(10) (BUF(I+J*NWORD),I=1,NWORD), CTRLE, CR, LF
      RETURN
      END
