CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
* Program to send a MONGO vector file to an Imagen 300dpi laser printer
      parameter (nin=2048, nbuf=1048576, laserwidth=2550)
      integer*2 sign, buf(nbuf), m1, m2, ix0, iy0, cbuf(4*laserwidth)
      integer*2 ix1, iy1
      integer px2, py2
      character*128 line
      character x1(2), y1(2), x0(2), y0(2)
      character*2 drawit
      character*3 newpath, newpoint
      equivalence (m1,x1), (m2,y1), (ix0,x0), (iy0,y0)
      character*4 xyprev, xynow
* byteswap is true for machines with low-byte-first word convention
* .true. for VAX, .false. for 68000
      logical byteswap
      data sign /-32768/
      data iunit /2/
      data byteswap /.true./

1000  format(a)

******************************************************************************
* Vector file contains pairs of 16 bit numbers according to:                 *
*    Sign 1   Sign 2   Mantissa 1   Mantissa 2   Meaning                     *
*      0        0          x            y        Draw a dot at (x,y)         *
*      1        0          x            y        Relocate at (x,y)           *
*      0        1          x            y        Draw to (x,y)               *
*      1        1        32767        32767      End of vector file          *
*      1        1          0            0        Finish plot, start new page *
*      1        1          1            n        Line weight = n             *
*      1        1          2            n        Line type = n               *
* (x,y) are oriented in portrait mode                                        *
******************************************************************************

      px2 = laserwidth
      py2 = nint(10.666667/8.5*laserwidth)

* Read in list of vectors and find how many there are
      open (unit=1,file='vectorfile',form='unformatted',status='old')
      ncoord = 0
      do 1 j = 1,nbuf/nin
          read(1,end=2) (buf(i+ncoord),i=1,nin)
          ncoord = ncoord + nin
1     continue
2     continue

       open(unit=iunit,file='plotfile',status='new',
     1			carriagecontrol='none')
C      open(unit=iunit,file='plotfile',form='unformatted',
C     1		status='unknown')

* Initialize the laser printer for portrait mode...

       line(1:11) = char(137)//char(12)//char(128) //
     1		char(205)//char(124) // char(213)
       write(iunit,1000) line(1:6)

* Run through the vectors, sending them to the printer
* Note that several passes may be necessary for multipage plots
      newpath = char(230) // char(0) // char(2)
      newpoint = char(230) // char(0) // char(1)
      drawit = char(234) // char(15)
      ltype = 0
      maxx = 0
20    continue
      minx = maxx
      maxx = maxx + laserwidth
      n = 0
      more = 0
      do 10 i = 1,ncoord,2
          i1 = iand(sign,buf(i))
          m1 = buf(i) - i1
          i2 = iand(sign,buf(i+1))
          m2 = buf(i+1) - i2
* Test to see whether the vector is on the present page
          if(i1.eq.0.or.i2.eq.0) then
              if(m1.gt.maxx) then
                  more = 1
                  goto 10
              else if(m1.lt.minx) then
                  goto 10
              end if
          end if

* If the current operation can exceed the line length, write the line
          if(n.gt.128-13) then
              write(iunit,1000) line(:n)
              n = 0
          end if
* point or draw?
          if(i1.eq.0) then
              m1 = m1 - minx
              if(byteswap) then
                  xynow = x1(2)//x1(1)//y1(2)//y1(1)
              else
                  xynow = x1(1)//x1(2)//y1(1)//y1(2)
              end if
              if(i2.eq.0) then
* point at m1, m2
                  line(n+1:n+9) = newpoint//xynow//drawit
                  xyprev = xynow
                  n = n + 9
              else
* draw to m1, m2
* If LTYPE = 0 (solid line) no problem; otherwise call chopper
                  if(ltype.eq.0) then
                      line(n+1:n+13) = newpath//xyprev//xynow//drawit
                      n = n + 13
                      xyprev = xynow
                      goto 10
                  end if
                  call chopper(ix0,iy0,m1,m2,ltype,1,px2,py2,cbuf,nv)
                  ix1 = m1
                  iy1 = m2
                  do 15 j = 1,nv,4
                      ix0 = cbuf(j)
                      iy0 = cbuf(j+1)
                      m1 = cbuf(j+2)
                      m2 = cbuf(j+3)
                      if(byteswap) then
                          xyprev = x0(2)//x0(1)//y0(2)//y0(1)
                          xynow = x1(2)//x1(1)//y1(2)//y1(1)
                      else
                          xyprev = x0(1)//x0(2)//y0(1)//y0(2)
                          xynow = x1(1)//x1(2)//y1(1)//y1(2)
                      end if
                      if(n.gt.128-13) then
                          write(iunit,1000) line(:n)
                          n = 0
                      end if
                      line(n+1:n+13) = newpath//xyprev//xynow//drawit
                      n = n + 13
15                continue
                  ix0 = ix1
                  iy0 = iy1
                  xyprev = xynow
              end if
* relocate or special?
          else
* relocate at m1, m2
              if(i2.eq.0) then
                  ix0 = m1 - minx
                  iy0 = m2
                  if(byteswap) then
                      xyprev = x0(2)//x0(1)//y0(2)//y0(1)
                  else
                      xyprev = x0(1)//x0(2)//y0(1)//y0(2)
                  end if
* end of buffer
              else if(m1.eq.32767) then
                  goto 11
* eject page, start new one
              else if(m1.eq.0) then
                  if(n.gt.0) write(iunit,1000) line(:n)
                  n = 0
                  write(iunit,1000) char(219)
* set line weight
              else if(m1.eq.1 .and. m2.le.20) then
                  line(n+1:n+3) = char(232)//char(m2)
                  n = n + 2
* set line type
              else if(m1.eq.2.and.m2.ge.0.and.m2.le.6) then
                  ltype = m2
              end if
          end if
10    continue

11    continue
      if(more.eq.0) goto 999
      if(n.gt.0) write(iunit,1000) line(:n)
      write(iunit,1000) char(219)
      goto 20

999   continue
* Write the LINE buffer if it is not empty and print the page
* Finish up the plot
      if(n.gt.0) write(iunit,1000) line(:n)
      write(iunit,1000) char(219)
      write(iunit,1000) char(255)

      stop
      end

      function nch(s)
      character*(*) s
      do 900 i = len(s),1,-1
          nch = i
          if(s(i:i).ne.' '.and.ichar(s(i:i)).ne.0) return
900   continue
      return
      end
