/*CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC*/
#include <stdio.h>

#define MIN(a,b) (((a) < (b)) ? (a) : (b))
#define MAX(a,b) (((a) > (b)) ? (a) : (b))
#define ABS(a) (((a) > 0) ? (a) : -(a))

extern struct {
  int mxarray;
  int dataptr[26];
  int dataint[26];
  int datamax[26];
  int datasize[26];
  float datarray;
} mgoarray_;

/* This is a start: just allocate an array of the requested size */
mgoallocarray_(which, size, len)
int *size, len;
char *which;
{
  int idx;
  float *ptr, *start;
  if(which[0] >= 'A' && which[0] <= 'Z') {
    idx = which[0] - 'A';
  } else if(which[0] >= 'a' && which[0] <= 'z') {
    idx = which[0] - 'a';
  } else {
    fprintf(stderr,"Cannot allocate array %c (%d)\n", which[0], which[0]);
    return(1);
  }

  if(mgoarray_.dataptr[idx] >= 0) {
    fprintf(stderr,"Array %c already allocated\n", which[0]);
    return(2);
  }

  ptr = (float *)calloc(*size, sizeof(float));
  if(ptr < 0) {
    fprintf(stderr, "Probably serious error, space allocated for array lies\n");
    fprintf(stderr, "at lower address than fortran array start\n");
    fprintf(stderr, "Maybe things will still work.  I doubt it though\n");
  }
  start = &(mgoarray_.datarray);
  mgoarray_.dataptr[idx] = (int)(ptr - start);
  mgoarray_.dataint[idx] = 0;
  mgoarray_.datamax[idx] = *size;
  mgoarray_.datasize[idx] = 0;
/*
  printf("Allocated %c, ptr = %d, size = %d,", which[0],
	 mgoarray_.dataptr[idx], mgoarray_.datamax[idx]);
  printf(" calloc @ %d, datarray @ %d\n", ptr, start);
*/
  return(0);
  
}
