CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c-----------------------------------------------------------
      subroutine mgogrwrite(n,buf)
c
c  Modified 13 Dec. 1982 by RHLupton + SJRatcliff for use at
c    Princeton on VAX 11/750 (Astrovax) + UNIX + Grinnell, com-
c    patable with the TAMcGlynn CALCOMP-ish plotting package.
c
c  Compile with -I2 option ; link in uopen,ucreat,uclose, and
c    uwrite from the outside world (i.e. from the famous util.a)
c
      parameter (nbuf=2048)
      integer*2 buf(1), outbuf(nbuf)
      integer*4 ipoint
      data ipoint /0/

      if (n+ipoint .gt. nbuf) then
        call mgogrbufout(ipoint,outbuf)
        ipoint = 0
      endif

      do 111 j = 1,n
        outbuf(j+ipoint) = buf(j)
111      continue
      ipoint = ipoint + n

      return

      entry mgogrflush
      call mgogrbufout(ipoint,outbuf)
      ipoint = 0
      return
      end
c
c----------------------
c
      subroutine mgogrbufout(n,outbuf)
c
c  This subroutine replaces the VMS version.
c
      common /MGOXXPLOT/ igrin,opnflg,scaler,xorig,yorig,ix,iy,
     &        wrblk(10),fflag, cflag, tflag, nflag, xflag
      integer*2 outbuf(1),icheck,mgouwrite
c              
c           uwrite is actually the system call write
c
      call mgogopt(.true.,.false.,.false.,.false.,.false.)
      call mgogopen
      icheck = mgouwrite(igrin,outbuf,2*n)
      if (icheck .eq. 2*n) return
c
      write (7,1000) icheck
 1000 format(1x,'write error in grbufout: ',i4,' bytes written')
      return
      end
c
c--------------
c
      subroutine mgogrclose
c
c  Simply call TAMcGlynn's gclose
c
      call mgogclose
      return
      end
c
c-------------------------------------------------------------------------
c
c  The following are the necessary subroutines from the TAMcGlynn
c    plotting package.  System calls cast into FORTRAN subroutines
c    which are referenced (though not necessarily used) include :
c        ucreat  (creat)
c        uopen   (open)
c        uwrite  (write)
c        uclose  (close)
c
      subroutine mgogopen
c
      common /MGOXXPLOT/ igrin,opnflg,scaler,xorig,yorig,ix,iy,
     &        wrblk(10),fflag, cflag, tflag, nflag, xflag
      logical fflag,cflag,tflag,nflag,xflag
      logical opnflg,first
      real xorig,yorig
      integer igrin,ix,iy
      integer wrblk,mgoucreat,mgouopen
      integer*2 mgouwrite, icheck
      save first
      data first /.true./
c
      if (first) then
      		first = .false.
      		opnflg = .false.
      	   endif
      if (opnflg) return
c
      if (.not. fflag) then
      	igrin=mgoucreat('#plot',420)
c
c  Check if open successful.
c
      	if (igrin .lt. 0) then
c
      		igrin=-1
      		write(6,*) 'Attempt to create #plot unsuccessful'
      		return
      		endif
      else
      	igrin= mgouopen('/dev/grin', 2)
      	if (igrin .lt. 0) then
                      igrin= -1
      		write(6,*) 'Attempt to open Grinnell unsuccessful'
      		return
      		endif
      endif
c
      opnflg=.true.
      scaler=50.
      ix=0.
      iy=0.
      xorig=1.0
      yorig=1.0
c
c  Check if cflag set.
c
      if (cflag) return
c
      wrblk(1)= -32768 + 4095
      wrblk(2)= 4096 + 4095
      wrblk(3)= 10240 + 80
      wrblk(4)= 11264 + 0
      wrblk(5)= 26624 + 0
      wrblk(6)= 18432 + 0
      wrblk(7)= 20480 + 1
      wrblk(8)=   12288
      wrblk(9)= -24576 + 8
      wrblk(10)= -16384 + 0
      icheck = mgouwrite(igrin,wrblk,20)
c
      return
      end
c------
      subroutine mgogopt(a,b,c,d,e)
c
      common /MGOXXPLOT/ igrin,opnflg,scaler,xorig,yorig,ix,iy,
     &        wrblk(10),fflag, cflag, tflag, nflag, xflag
      logical fflag,cflag,tflag,nflag,xflag
      logical opnflg
      real xorig,yorig
      integer igrin,ix,iy,wrblk
c
      logical a,b,c,d,e
      fflag=a
      cflag=b
      tflag=c
      nflag=d
      xflag=e
      return
      end
c------
      subroutine mgogclose
c
c  This entry closes the Grinnell.
c
      common /MGOXXPLOT/ igrin,opnflg,scaler,xorig,yorig,ix,iy,
     &        wrblk(10),fflag, cflag, tflag, nflag, xflag
      logical fflag,cflag,tflag,nflag,xflag
      logical opnflg
      real xorig,yorig
      integer igrin,ix,iy,wrblk
c
      if (opnflg) call mgouclose(igrin)
      opnflg=.false.
      return
c
      end
c--------------------------------------------------------------------------

      subroutine mgogrread(n,buf)
      integer*2 buf(1)
      return
      end
