CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine mgoinit
      character*80 ename, evalue
      character*128 line
      include 'mongo.par'
      include 'vocab.par'
      include 'luns.par'
      include 'files.par'
      include 'arrays.par'
      logical firstime
      data firstime /.true./

* Occasionally people don't realize that MGOINIT should only be called *once*
      if(.not.firstime) return
      firstime = .false.

* First initialize common variables to compilation defaults
C     initialize logical unit numbers
      stderr = 0
      stdin = 5
      stdout = 6
      veclun = 7
      cmdlun = 8
      fontlun =8 
      helplun = 8
      maclun = 8
      plotlun = 9
      datalun = 10
      inputlun = 11

* Use input processing?
      inproc = 1

C Initialize data array parameters
      internal = .false.
      nrow = 1
      ncol = 1
      nstyle = 0
      form = 'FREE'

C Initialize filename common block
      helpfile = '/usr/local/lib/mongo/help.dat'
      fontfile = '/usr/local/lib/mongo/fonts.bin'
      parfile = '/usr/local/lib/mongo/mongo.params'
      do 110 i = 1,maxterm
         termdev(i) = '/dev/tty'
 110  continue
      rastercmd = ' '
C Initialize default terminal and printer
      lastterm = 3
      lastprnt = -6
      ncmd = 0
      do 100 i = 1,maxprint
         lcmd(i) = 0
 100  continue

C Initialize MONGO parameter block
      x1 = 0
      x2 = 1
      y1 = 0
      y2 = 1
      gx1 = 0
      gx2 = 1
      gy1 = 0
      gy2 = 1
      expand = 1
      angle = 0
      ltype = 0
      lweight = 1
      cxdef = 3
      cydef = 3
      pxdef = 5
      pydef = 5
      coff = 0
      termout = .false.
      xyswapped = .false.
      numdev = 3
      autodot = .false.
      autoweight = .false.
      autochar = .false.
      pi = 3.14159265
      icolor = -1
      fillmode = 0
      inmode = 111
      ptype = 40
      expx = 1
      expy = 1
      xfudge = 2
      yfudge = 6
      parfudge = 0.65
      perfudge = 0.5

* Default array size
      mxarray = 20000

C Initialize vocab.par common blocks.
C Note that the last entry must be 'buffer' and that the first character
C determines whether ( /*) a command is saved in the buffer
      nmac = 1
      macbeg(nmac) = 1
      maclen(nmac) = 0
      bufend = 1
      macend = 50000
      ifskip = 0
      nbreak = 0
      vocab( 1) = ' 3dplot'
      vocab( 2) = ' angle'
      vocab( 3) = ' axis'
      vocab( 4) = ' box'
      vocab( 5) = ' connect'
      vocab( 6) = ' contour'
      vocab( 7) = ' cursor'
      vocab( 8) = ' data'
      vocab( 9) = '*define'
      vocab(10) = '*delete'
      vocab(11) = ' device'
      vocab(12) = ' dot'
      vocab(13) = ' draw'
      vocab(14) = ' ecolumn'
      vocab(15) = '*end'
      vocab(16) = '*erase'
      vocab(17) = ' errorbar'
      vocab(18) = ' expand'
      vocab(19) = ' format'
      vocab(20) = ' grid'
      vocab(21) = ' id'
      vocab(22) = ' input'
      vocab(23) = '*insert'
      vocab(24) = ' halftone'
      vocab(25) = '*hardcopy'
      vocab(26) = '*help'
      vocab(27) = ' histogram'
      vocab(28) = ' label'
      vocab(29) = ' limits'
      vocab(30) = ' lines'
      vocab(31) = '*list'
      vocab(32) = ' location'
      vocab(33) = ' ltype'
      vocab(34) = ' lweight'
      vocab(35) = ' page'
      vocab(36) = ' pcolumn'
      vocab(37) = ' physical'
      vocab(38) = '*playback'
      vocab(39) = ' points'
      vocab(40) = '*printer'
      vocab(41) = ' ptype'
      vocab(42) = ' putlabel'
      vocab(43) = ' relocate'
      vocab(44) = '*reset'
      vocab(45) = ' set'
      vocab(46) = '*show'
      vocab(47) = '*terminal'
      vocab(48) = ' ticksize'
      vocab(49) = ' vfield'
      vocab(50) = ' window'
      vocab(51) = '*write'
      vocab(52) = ' xcolumn'
      vocab(53) = ' xlabel'
      vocab(54) = ' xlogarithm'
      vocab(55) = ' ycolumn'
      vocab(56) = ' vcolumn'
      vocab(57) = ' lcolumn'
      vocab(58) = ' ucolumn'
      vocab(59) = ' lpoints'
      vocab(60) = ' ylabel'
      vocab(61) = ' ylogarithm'
      vocab(62) = ' color'
      vocab(63) = ' fill'
      vocab(64) = '*info'
      vocab(65) = ' poly'
      vocab(66) = ' spline'
      vocab(67) = ' if'
      vocab(68) = ' break'
      vocab(69) = '*rename'
      vocab(70) = ' execute'
      vocab(71) = '*buffer'
C NBUILTIN = last command before "buffer" (which is considered a macro)
      nbuiltin = 70
      do 102 i = nbuiltin+2,maxvocab
         vocab(i) = ' '
 102  continue

* Next check to see if (old-style) "MONGOFILES"; if so, load up contents
 20   continue
      ename = 'MONGOFILES'
      call getenv(ename,evalue)
      if(evalue(:10).eq.'          ') goto 30
      open(unit=cmdlun,file=evalue,err=21,status='old')
 1000 format(a)
      line = ' '
      read(cmdlun,1000,err=21,end=21) helpfile
      read(cmdlun,1000,err=21,end=21) fontfile
      read(cmdlun,1000,err=21,end=21) line
      read(cmdlun,*,err=21,end=21) lastterm, termdev(lastterm), lastprnt
      goto 22
 21   call mgoerr('Error reading MONGOFILES initialization file')
      call mgoerr('You should unset MONGOFILES and use MONGOPAR')

 22   close(cmdlun)
      

      open(unit=cmdlun,file=line,status='old',err=23)
      do 200 i = 1,maxprint
         lcmd(i) = 0
         read(cmdlun,1000,end=200,err=23) pcmd(i)
         ncmd = ncmd + 1
         lcmd(i) = mgolenc(pcmd(i))
 200  continue

      goto 30
 23   call mgoerr('Error reading raster command initialization file')

* Third, check to see whether (new-style) "MONGOPAR" is defined
 30   close(cmdlun)
      ename = 'MONGOPAR'
      call getenv(ename,evalue)
      if(evalue(:10).eq.'          ') then
         open(unit=cmdlun,file=parfile,err=31,status='old')
      else
         open(unit=cmdlun,file=evalue,err=31,status='old')
      end if

      do 300 i = 1,1000
         read(cmdlun,1000,err=31,end=40) line
         if(line(1:1).eq.'#') goto 300

         if(line(:8).eq.'HELPFILE') then
            call mgoparead(line,helpfile)

         else if(line(:8).eq.'FONTFILE') then
            call mgoparead(line,fontfile)

         else if(line(:8).eq.'RASTER12') then
            call mgoparead(line,pcmd(1))
            lcmd(1) = mgolenc(pcmd(1))
            ncmd = max(ncmd,1)

         else if(line(:8).eq.'RASTER34') then
            call mgoparead(line,pcmd(2))
            lcmd(2) = mgolenc(pcmd(2))
            ncmd = max(ncmd,2)

         else if(line(:8).eq.'RASTER56') then
            call mgoparead(line,pcmd(3))
            lcmd(3) = mgolenc(pcmd(3))
            ncmd = max(ncmd,3)

         else if(line(:8).eq.'RASTER78') then
            call mgoparead(line,pcmd(4))
            lcmd(4) = mgolenc(pcmd(4))
            ncmd = max(ncmd,4)

         else if(line(:8).eq.'TERMINAL') then
            call mgoparead(line,ename)
            read(ename,'(i1,1x,a)',err=300) lastterm, termdev(lastterm)

         else if(line(:7).eq.'PRINTER') then
            call mgoparead(line,ename)
            read(ename,'(i1)',err=300) l
            lastprnt = -l

         else if(line(:9).eq.'ARRAYSIZE') then
            call mgoparead(line,ename)
            read(ename,'(i9)',err=300) mxarray

         else if(line(:7).eq.'MONGOIN') then
            call mgoparead(line,ename)
            read(ename,'(i9)',err=300) inproc

         else
            call mgoerr2('Unknown MONGOPAR keyword', line(:8))
         end if
 300  continue
      goto 40
 31   call mgoerr('Error reading MONGOPAR initialization file')

* Finally, check the environment for overrides
 40   close(cmdlun)
      ename = 'MONGOTERM'
      call getenv(ename,evalue)
      if(evalue(:10).ne.'          ') then
         termdev(lastterm) = evalue
      end if

 41   continue
      ename = 'MONGODEV'
      call getenv(ename,evalue)
      i = index(evalue,':')
      if(i.ne.0) then
         read(evalue(:i-1),'(i2)',err=42) lastterm
         termdev(lastterm) = evalue(i+1:)
      else if(evalue(:5).ne.'     ') then
         termdev(lastterm) = evalue
      end if

 42   continue
      ename = 'MONGOPRINT'
      call getenv(ename,evalue)
      if(evalue(:10).ne.'          ') then
         rastercmd = evalue
      end if

      ename = 'MONGOSIZE'
      call getenv(ename,evalue)
      if(evalue(:10).ne.'          ') read(evalue,'(i9)',err=43) mxarray
 43   continue

      ename = 'MONGOIN'
      call getenv(ename,evalue)
      if(evalue(:10).ne.'          ') read(evalue,'(i9)',err=44) inproc
 44   continue

* Initialize data array pointers and sizes
      do 101 i = 1,26
         dataptr(i) = -1
         dataint(i) = 0
         datasize(i) = 0
         datamax(i) = 0
 101  continue
* These have been retired in favor of dynamic allocation of arrays
C      dataptr(ichar('X')-ichar('A')+1) = 1
C      datamax(ichar('X')-ichar('A')+1) = mxx
C      dataptr(ichar('Y')-ichar('A')+1) = mxx + 1
C      datamax(ichar('Y')-ichar('A')+1) = mxy
C      dataptr(ichar('E')-ichar('A')+1) = mxx+mxy + 1
C      datamax(ichar('E')-ichar('A')+1) = mxe
C      dataptr(ichar('U')-ichar('A')+1) = mxx+mxy+mxe + 1
C      datamax(ichar('U')-ichar('A')+1) = mxu
C      dataptr(ichar('V')-ichar('A')+1) = mxx+mxy+mxe+mxu + 1
C      datamax(ichar('V')-ichar('A')+1) = mxv
C      dataptr(ichar('P')-ichar('A')+1) = mxx+mxy+mxe+mxu+mxv + 1
C      datamax(ichar('P')-ichar('A')+1) = mxp
      call mgoallocarray('X', MXARRAY)
      call mgoallocarray('Y', MXARRAY)
      call mgoallocarray('E', MXARRAY)
      call mgoallocarray('U', MXARRAY)
      call mgoallocarray('V', MXARRAY)

      call mgoallocarray('P', MXARRAY)
      dataint(ichar('P')-ichar('A')+1) = 1

      datamax(ichar('L')-ichar('A')+1) = mxlabel
      dataint(ichar('L')-ichar('A')+1) = -1

      return
      end

      subroutine mgoparead(line,token)
      character*(*) line, token
      l = len(line)
      i = index(line,'=') + 1
      if(i.eq.1) then
         token = ' '
         return
      end if
 10   if(i.lt.l .and. line(i:i).eq.' ') then
         i = i + 1
         goto 10
      end if
      token = line(i:)
      return
      end

