/*CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC*/
#include <stdio.h>
#include <signal.h>
#include <suntool/gfx_hs.h>

char buffer[1024];

/* The f77 version of system is frequently broken */
mgosystem_(cmd,cmdlen)
char *cmd;
int cmdlen;
{
  strcpy(buffer,cmd);
  return(system(buffer));
}

struct gfxsubwindow *gfx ;
int sigwinched(), mousex, mousey ;

DEFINE_CURSOR(crosshair, 7, 7, PIX_SRC ^ PIX_DST,
	0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0000, 0xFC7E,
	0x0000, 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0000) ;

/* Select output window */
mgosunwinselect_(name,namelen)
int namelen ;
char *name ;
{
	we_setgfxwindow(name) ;
}

/* Open a window and return the size of the window as (x,y) */
mgosunwinopen_(x,y)
int *x, *y ;
{
	int damage ;
	if( gfx == NULL ) {
		if((gfx = gfxsw_init(0,NULL)) == NULL) {
			fprintf(stderr,"Unable to open graphics subwindow\n") ;
			return ;
		}	
		gfxsw_getretained(gfx) ;
		signal(SIGWINCH,sigwinched) ;
		win_setcursor(gfx->gfx_windowfd,&crosshair) ;
	}
	checkdamage(gfx,damage) ;
	*x = gfx->gfx_rect.r_width ;
	*y = gfx->gfx_rect.r_height ;
}

/* Draw a vector in the window from (x1,y1) to (x2,y2) */
mgosunwinvec_(x1,y1,x2,y2)
int *x1, *x2, *y1, *y2 ;
{
	int op=PIX_SRC, ymax ;
	ymax = gfx->gfx_rect.r_height ;
	pw_vector(gfx->gfx_pixwin,*x1,ymax-*y1,*x2,ymax-*y2,op,1) ;
}

/* Write n characters from the string c starting at (x,y) */
mgosunwinchar_(x,y,n,c,clen)
int *x, *y, *n, clen ;
char *c ;
{
	int op=PIX_SRC, ymax ;
	c[*n] = '\0' ;
	ymax = gfx->gfx_rect.r_height ;
	pw_text(gfx->gfx_pixwin,*x,ymax-*y,op,NULL,c) ;
}

/* If r = 0, put the cursor at x,y; if r=1, wait on mouse and return x,y */
mgosunwincurs_(x,y,r)
int *x, *y, *r ;
{
	Inputmask im ;
	Event ie ;
	int ymax ;
	ymax = gfx->gfx_rect.r_height ;
	if(*r == 0) {
		win_setmouseposition(gfx->gfx_windowfd,*x,ymax-*y) ;
		return ;
	}
	input_imnull(&im) ;
	win_setinputcodebit(&im,MS_LEFT) ;
	win_set_pick_mask(gfx->gfx_windowfd,&im);
	input_readevent(gfx->gfx_windowfd, &ie) ;
	*x = event_x(&ie) ;
	*y = ymax - event_y(&ie) ;
}

/* Erase the graphics window */
mgosunwinerase_()
{
	pw_writebackground(gfx->gfx_pixwin, 0, 0,
		gfx->gfx_rect.r_width, gfx->gfx_rect.r_height, PIX_CLR) ;
}

/* Dummy routine to set color */
mgosunwincolor_(c)
int *c ;
{
}

/* Dummy routine to set color */
mgosunwinpalette_(c,palette)
/* Add to the current palette */
int *c;
short int *palette;
{
}

/* Close the graphics subwindow */
mgosunwinclose_()
{
	int damage ;
	checkdamage(gfx,damage) ;
}

/* Idle the graphics subwindow */
mgosunwinidle_()
{
}

checkdamage(gfxw,damage)
/* Check the window for damage and fix it if possible */
struct gfxsubwindow *gfxw ;
int damage ;
{
	damage = 0 ;
	if(gfxw->gfx_flags & GFX_DAMAGED) {
		gfxsw_handlesigwinch(gfxw) ;
		damage = GFX_DAMAGED ;
	}
	if(gfxw->gfx_flags & GFX_RESTART) {
		gfxw->gfx_flags &= ~GFX_RESTART ;
		damage = GFX_RESTART ;
	}
}

sigwinched()
{
	gfxsw_interpretesigwinch(gfx) ;
	gfxsw_handlesigwinch(gfx) ;
	if(gfx->gfx_flags & GFX_RESTART) {
		gfx->gfx_flags &= ~GFX_RESTART ;
		mgosunsetup_() ;
	}
}


