/*CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC*/
#include <stdio.h>
#include <sys/file.h>
#include <fcntl.h>

#include "../include/cfiles.h"

#define MIN(a,b) (((a) < (b)) ? (a) : (b))

#define BUFLEN 256
unsigned char ttbuf[BUFLEN];
int bufpt=0, ttfd=(-1);
int cterm=0;

mgottwrite_(nchar,buf,buflen)
int *nchar, buflen;
unsigned char *buf;
{
  int i;
  for(i=0;i<*nchar;i++) {
    ttbuf[bufpt++] = buf[i];
    if(bufpt >= BUFLEN) if(mgottbufout()) return;
  }
}

mgottflush_()
{
  mgottbufout();
}

mgottbufout()
{
  int nwritten;
  if( bufpt == 0) return(0);
  mgottopen();
  if( (nwritten = write(ttfd,ttbuf,bufpt)) != bufpt) {
    fprintf(stderr,"Error writing: nreq = %d, nwrite = %d\n",bufpt,nwritten);
    return(1);
  }
  bufpt = 0;
  return(0);
}

mgottopen()
{
/* Open I/O to the terminal if not already open */
  char fname[DEVSIZE];
  int i;
  if(ttfd == -1) {
    cterm = mgofiles_.lastterm - 1;
    strncpy(fname,mgofiles_.termdev[cterm],DEVSIZE);
    for(i=DEVSIZE; i>0; i--) {
      if(fname[i-1] != ' ') {
	fname[i] = '\0';
	break;
      }
    }
    if( (ttfd = open(fname,O_RDWR,0644)) < 0) {
      fprintf(stderr,"Cannot open output device %s\n",fname) ;
      return(1) ;
    }
  }
}

mgottclose_()
{
  close(ttfd);
  ttfd = -1;
}

mgottread_(nchar,inbuf,buflen)
int *nchar, buflen;
char *inbuf;
{
  int nread;
  *nchar = read(ttfd,inbuf,buflen) ;
}

mgotermname_(name,error,namelen)
int *error, namelen;
char *name;
{
  int i;
  if(mgottbufout()) return;
  cterm = mgofiles_.lastterm - 1;
  for(i=0;i<DEVSIZE;i++) mgofiles_.termdev[cterm][i] = ' ';
  strncpy(mgofiles_.termdev[cterm],name,MIN(namelen,DEVSIZE));
}
